<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <!-- <el-form-item label="所属公司" prop="companyId" v-if="shouldShowCompanySelect">
        <el-select v-model="queryParams.companyId" placeholder="请选择所属公司" clearable size="small">
          <el-option v-for="item in companyList" :key="item.companyId" :label="item.companyName"
            :value="item.companyId">
          </el-option>
        </el-select>
      </el-form-item> -->
      <el-form-item label="设备编号" prop="deviceId">
        <el-input v-model="queryParams.deviceId" placeholder="请输入设备编号" clearable size="small"
          @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item label="物料名称" prop="materialsName">
        <el-input v-model="queryParams.materialsName" placeholder="请选择物料名称" clearable size="small"
          @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['watchApi:materials:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['watchApi:materials:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['watchApi:materials:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" :loading="exportLoading"
          @click="handleExport" v-hasPermi="['watchApi:materials:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="materialsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="所属公司" align="center" prop="companyName" /> -->
      <el-table-column label="设备编号" align="center" prop="deviceId" />
      <el-table-column label="物料名称" align="center" prop="materialsName" />
      <el-table-column label="现有数量" align="center" prop="availableNum" />
      <el-table-column label="已使用数量" align="center" prop="usedNum" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['watchApi:materials:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['watchApi:materials:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改设备物料信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <!-- <el-form-item label="所属公司" prop="companyName">
          <el-input v-model="form.companyName" placeholder="自动绑定所属公司" disabled />
        </el-form-item> -->
        <el-form-item label="设备编号" prop="deviceId">
          <el-input v-model="form.deviceId" placeholder="请输入设备编号" @blur="fetchCompanyByDeviceId" />
        </el-form-item>

        <el-form-item label="物料名称" prop="materialsId">
          <el-select v-model="form.materialsId" placeholder="请选择物料名称" clearable size="small"
            @change="handleMaterialChange">
            <el-option v-for="item in typeList" :key="item.materialsId" :label="item.materialsName" :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="现有数量" prop="availableNum">
          <el-input v-model="form.availableNum" placeholder="请输入现有数量" />
        </el-form-item>
        <el-form-item label="已用数量" prop="usedNum">
          <el-input v-model="form.usedNum" placeholder="请输入已使用数量" />
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listMaterials, getMaterials, delMaterials, addMaterials, updateMaterials, exportMaterials } from "@/api/watch/materials";
import { listType } from "@/api/watch/materialsType";
// import { getCompanyList } from "@/api/company/company";
import { getDeviceInfoByNumber } from "@/api/watch/deviceInfo";

export default {
  name: "Materials",
  data() {
    return {
      // 公司信息表格数据
      companyList: [],
      //物料类型表格数据
      typeList: [],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备物料信息表格数据
      materialsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        companyId: null,
        deviceId: null,
        materialsId: null,
        materialsName: null,
        availableNum: null,
        usedNum: null,
        isDel: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        // companyId: [
        //   { required: true, message: "请选择所属公司", trigger: "change" }
        // ],
        deviceId: [
          { required: true, message: "设备编号不能为空", trigger: "blur" },
          { pattern: /^\d{15}$/, message: "设备编号必须是15位数字", trigger: "blur" }
        ],
        materialsName: [
          { required: true, message: "请输入物料名称", trigger: "blur" }
        ],
        availableNum: [
          { required: true, message: "请输入现有数量", trigger: "blur" }
        ],
        usedNum: [
          { required: true, message: "请输入已使用数量", trigger: "blur" }
        ]
        // 其他校验规则
      },
    };
  },
  created() {
    this.getList();
    this.getCompanyList();
    this.getTypeList();
  },
  methods: {
    // shouldShowCompanySelect() {
    //   // 根据登录用户信息判断是否显示所属公司选择框
    //   const roles = this.$store.getters.roles; // 获取角色信息
    //   // 只有包含 'admin' 或 'common' 才返回 true
    //   return (roles.includes('admin') || roles.includes('common'));
    // },
    /**根据输入的设备编号绑定公司 */
    async fetchCompanyByDeviceId() {
      if (!this.form.deviceId) return;

      try {
        // 假设你有一个 API 接口来根据设备编号获取公司信息
        const response = await getDeviceInfoByNumber({ "deviceNumber": this.form.deviceId });

        if (response && response.data) {
          this.form.companyId = response.data.companyId; // 更新公司ID
          this.form.companyName = response.data.companyName; // 更新公司名称
        } else {
          this.form.companyId = null;
          this.form.companyName = null;
        }
      } catch (error) {
        this.$message.error('获取公司信息失败');
        this.form.companyId = null;
        this.form.companyName = null;
      }
    },
    /** 选择物料类型后绑定物料id */
    handleMaterialChange(value) {
      const selectedMaterial = this.typeList.find(item => item.id === value);
      if (selectedMaterial) {
        // console.log("------------------" + JSON.stringify(selectedMaterial, null, 2))
        this.form.materialsName = selectedMaterial.materialsName;
      } else {
        this.form.materialsName = null;
      }
    },
    /** 查询物料种类 */
    getTypeList() {
      this.loading = true;
      listType().then(response => {
        this.typeList = response.rows;
        this.loading = false;
      });
    },
    /** 查询所有公司 */
    getCompanyList() {
      this.loading = true;
      if (this.shouldShowCompanySelect()) {
        getCompanyList().then(response => {
          this.companyList = response.data;
          this.loading = false;
        });
      }
    },
    /** 查询设备物料信息列表 */
    getList() {
      this.loading = true;
      listMaterials(this.queryParams).then(response => {
        this.materialsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        companyId: null,
        deviceId: null,
        materialsId: null,
        materialsName: null,
        availableNum: null,
        usedNum: null,
        createTime: null,
        updateTime: null,
        isDel: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加设备物料信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getMaterials(id).then(response => {
        this.form = response.data;
        // 根据物料 ID 从 typeList 中找到物料名称，并设置到表单中
        const selectedMaterial = this.typeList.find(item => item.materialsId === this.form.materialsId);
        if (selectedMaterial) {
          this.form.materialsName = selectedMaterial.materialsName;
        }
        this.open = true;
        this.title = "修改设备物料信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateMaterials(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMaterials(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除设备物料信息编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delMaterials(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有设备物料信息数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        this.exportLoading = true;
        return exportMaterials(queryParams);
      }).then(response => {
        this.download(response.msg);
        this.exportLoading = false;
      }).catch(() => { });
    }
  }
};
</script>
